Attribute VB_Name = "StrikesCOGParser"
Public cogLines as Integer
Public objectCount as Single

Sub CountCog(fileN As String)
' ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' +++++++++++++++ This module was made in late 2002 and revised slightly in early 2003 +++++++++++++++
' ++++++++++++++++ It was written by BAH_Strike to help lazy hackers count objects in ++++++++++++++++
' +++++++++++++++++ COG files so that they would not checksum. You are free to use  ++++++++++++++++++
' ++++++++++++++++++ this module as long as you give proper credit to BAH_Strike.  +++++++++++++++++++
' +++++++++++++++++++        -   Enjoy this parser, I had fun making it!   -       +++++++++++++++++++
' ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

'  Note: See the PROGRAMMERS NOTE at the bottom of this module subroutine for extra info on use
'        and for the required notice to add to your program when using this module. kthx!


'  Other Note: Also, please excuse the occasional $ or % as this was originally written in QBasic where
'              some of that shit is required with non-predeclared variables.


' +++ Declare our crap (no, not all variables used in this source have been predeclared. Blow me) +++
Dim cogLine As String
Dim tmpLine As String
Dim x As Integer
Dim inCode As Integer
Dim inString As Integer
Dim inVector As Integer
Dim inOperator As Integer
Dim inCrap As Integer
Dim inParenthesis As Integer
Dim crap As String
Dim tmpSingle As String * 1
Dim numCurObjects As Single
Dim operators As String * 10
Dim ascii As String * 38
Dim skippedChars As String * 4


' +++ Set up our tables and other starting values +++
objectCount = 0
cogLines = 0
skippedChars = Chr$(9) + " {}"   ' ++ Skip spaces, tabs (ASCII Code 9), and brackets
operators = "+-*/!=<>&|": curPos% = 0
For x = 97 To 122: curPos% = curPos% + 1: Mid$(ascii, curPos%, 1) = Chr$(x): Next x
For x = 48 To 57: curPos% = curPos% + 1: Mid$(ascii, curPos%, 1) = Chr$(x): Next x
curPos% = curPos% + 1: Mid$(ascii, curPos%, 1) = "_"
curPos% = curPos% + 1: Mid$(ascii, curPos%, 1) = "."


' +++ Open up the file +++
Open fileN For Input As #1


' +++ Start of our loop - this loop processes the COG line by line +++
Do
	' +++ Get our COG line and prepare it for processing +++
        Line Input #1, cogLine
        cogLine = LCase$(cogLine)
        cogLines = cogLines + 1
        tmpLine = cogLine: cogLine = ""
        For x = 1 To Len(tmpLine)
                tmpSingle = Mid$(tmpLine, x, 1)
                If InStr(skippedChars, tmpSingle) = 0 Then cogLine = cogLine + tmpSingle
        Next x

       
	' +++ Cut off all comments while leaving whats to the left of them intact +++
        For x = 1 To Len(cogLine)
                If Mid$(cogLine, x, 1) = "#" Or Mid$(cogLine, x, 2) = "//" Then Exit For
        Next x
        If x < Len(cogLine) Then cogLine = Left$(cogLine, x - 1)


	' +++ If we've hit the end of the COG then stop processing +++
        If cogLine = "end" And inCode = 1 Then inCode = 0


	' +++ If we are between code and end, process the line +++
        If inCode = 1 Then

        numCurObjects = objectCount ' <--- Set this so we can subtract later and see how many objects were in this
				    '      particular line


	' +++ Ok, this is where the magic starts +++
        For x = 1 To Len(cogLine)
        tmpSingle = Mid$(cogLine, x, 1) ' <--- Get one character for processing

                If tmpSingle = Chr$(34) Then
                        ' +++ If we hit a quotation mark then remember that we're in a string +++
                        If inString = 0 Then
                                inString = 1
                        Else
			' +++ Since we were already in a string, cut it off and add 1 to the object count +++
                        inString = 0
                        objectCount = objectCount + 1
                        End If
                End If
If inString = 0 Then
		' +++ Only process this if we are not in a string +++
                If tmpSingle = "'" Then
                        ' +++ If we hit an apostrophe then remember we are in a vector +++
                        If inVector = 0 Then
                                inVector = 1
                        Else
			' +++ Since we are already in a vector, cut it off and add 2 to the object count +++
                        inVector = 0
                        objectCount = objectCount + 2
                        End If
                End If
If inVector = 0 Then
	' +++ only process this if we are not in a vector +++
        If InStr(ascii, tmpSingle) > 0 Then
                ' +++ If we hit any numbers, letters, or special characters we defined above (like underscores)
		'     then add this to the crap string +++
                inCrap = 1
                crap = crap + tmpSingle
        Else
		' +++ We hit a character OTHER than a number, letter, or special character as we defined above
		'     so cut it off and see what we have in the crap string +++
                If inCrap = 1 Then
                        inCrap = 0
                                Select Case crap
                                        ' +++ If we have a special case, handle it here
					'     NOTE: I MAY HAVE FORGOTTEN SOME, ADD THEM HERE IF NEED BE -
					'     SHOULD BE PRETTY EASY TO UNDERSTAND HOW TO ADD (if not then you're
					'     a moron) +++
                                        Case "return"
                                                objectCount = objectCount + 0.5
                                        Case "if"
                                                objectCount = objectCount + 1
                                        Case "while"
                                                objectCount = objectCount + 2
                                        Case "for"
                                                objectCount = objectCount + 2
                                        Case "else"
                                                objectCount = objectCount + 1
                                        Case Else
						' +++ If we didn't find a special object, then its probably a
						'     normal one, like a number, variable, or function name +++
                                                if tmpSingle <> ":" Then
							' +++ Messages have a : after them, so only add to the
							'     count if this is NOT a message +++
							objectCount = objectCount + 1
						End if
                                                If tmpSingle = "(" Then
                                                        ' +++ Functions have a ( right after them, so if there is
                                                        '     one than add the extra 1/2 object +++
                                                        objectCount = objectCount + 0.5
                                                End If
                                End Select

			' +++ Clear the crap string after we're done processing it +++
                        crap = ""
                End If
        End If


	' +++ Hey, this doesn't do anything! Kickass, eh? +++
        If tmpSingle = "(" Then
                inParenthesis = inParenthesis + 1
        ElseIf tmpSingle = ")" Then
                inParenthesis = inParenthesis - 1
        End If


	' +++ Time to detect operators +++
        If InStr(operators, tmpSingle) > 0 Then
                ' +++ We've found one +++
                inOperator = inOperator + 1 ' <--- We can keep track of up to 2 operators
                If inOperator = 2 Then    ' +++ Don't let operators get past 2 long +++
                        inOperator = 0
                        objectCount = objectCount + 0.5
                        If tmpSingle = "-" Then
				' +++ Crap, the other half of the operator was a negative sign. Add extra 1/2 +++
                                objectCount = objectCount + 0.5
                        End If
                End If
        Else
	' +++ We did not find an operator +++
                If inOperator > 0 Then
			' +++ If we are in one, though, cut it off and add 0.5 (this is for operators one character
			'     long) +++
                        inOperator = 0
                        objectCount = objectCount + 0.5
                End If
        End If
End If
End If
        Next x ' <--- End of our parsing loop
       
        numCurObjects = objectCount - numCurObjects ' <--- Calculate the number of objects on this particular line

        End If

	' +++ If we hit the code section, begin allowing the parser to process the lines +++
        If cogLine = "code" Then inCode = 1


' +++ Keep processing lines until we hit the end of the file +++
Loop Until EOF(1)


' +++ Shutdown the parser +++
Close #1


' +++ NOTE FOR PROGRAMMERS:
'     After running CountCog "Filename.cog"
'     in your program, the public variable objectCount will now equal the total number of objects in the COG,
'     and cogLines will equal the total number of lines in the COG. Here's an example for complete morons on how
'     this is used +++

'     CountCog "C:\Windows\Desktop\my1337hack.cog"
'     Text1.Text = "The cog has" + Str(objectCount) + "objects in it."
'     Text2.Text = "The cog has" + Str(cogLines) + "lines in it."

' +++ Not too difficult, is it? If you use this module or any of the sourcecode within it in your program,
'     of course you're required to put somewhere the following (and it must be visible and easy to see. A good
'     place to put it is in the About section of your program). I ENCOURAGE you rip this source apart and
'     use what you wish in your programs. It'd be cool to see what some people could come up with +++

'     Thanks to BAH_Strike for COG Parser module
'         Copyright 2002-03 Bad Ass Hackers
End Sub
